#include <iostream>
using namespace std;

const int MAXN = 102;
const int MAXS = 102;

int n, s;
int a[MAXN], b[MAXN];

int dp[MAXS][MAXS][MAXS][2];
int sums[3];

int main()
{
    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i] >> b[i];
        sums[a[i] - 1] += b[i];
    }

    s = sums[0] + sums[1] + sums[2];
    if (s % 3 != 0 or s > 100)
    {
        cout << -1 << endl;
        return 0;
    }

    for (int i = 0; i <= s; ++ i)
    {
        for (int j = 0; j <= s; ++ j)
        {
            for (int k = 0; k <= s; ++ k)
            {
                dp[i][j][k][0] = dp[i][j][k][1] = n + 1;
            }
        }
    }

    dp[sums[0]][sums[1]][sums[2]][0] = dp[sums[0]][sums[1]][sums[2]][1] = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int p = 0; p <= s; ++ p)
        {
            for (int q = 0; q <= s; ++ q)
            {
                for (int r = 0; r <= s; ++ r)
                {
                    if (dp[p][q][r][0] == n + 1) continue;

                    if (a[i] == 1)
                    {
                        dp[p - b[i]][q + b[i]][r][1] = min(dp[p - b[i]][q + b[i]][r][1], dp[p][q][r][0] + 1);
                        dp[p - b[i]][q][r + b[i]][1] = min(dp[p - b[i]][q][r + b[i]][1], dp[p][q][r][0] + 1);
                    }
                    if (a[i] == 2)
                    {
                        dp[p + b[i]][q - b[i]][r][1] = min(dp[p + b[i]][q - b[i]][r][1], dp[p][q][r][0] + 1);
                        dp[p][q - b[i]][r + b[i]][1] = min(dp[p][q - b[i]][r + b[i]][1], dp[p][q][r][0] + 1);
                    }
                    if (a[i] == 3)
                    {
                        dp[p + b[i]][q][r - b[i]][1] = min(dp[p + b[i]][q][r - b[i]][1], dp[p][q][r][0] + 1);
                        dp[p][q + b[i]][r - b[i]][1] = min(dp[p][q + b[i]][r - b[i]][1], dp[p][q][r][0] + 1);
                    }
                }
            }
        }

        for (int p = 0; p <= s; ++ p)
        {
            for (int q = 0; q <= s; ++ q)
            {
                for (int r = 0; r <= s; ++ r)
                {
                    dp[p][q][r][0] = min(dp[p][q][r][0], dp[p][q][r][1]);
                }
            }
        }
    }

    if (dp[s / 3][s / 3][s / 3][0] == n + 1) cout << -1 << endl;
    else cout << dp[s / 3][s / 3][s / 3][0] << endl;

    return 0;
}

